/*
* Copyright (C) 2017, University of the Basque Country (UPV/EHU)
*  Contact for licensing options: <licensing-mcpttclient(at)mcopenplatform(dot)com>
*
* The original file was part of Open Source IMSDROID
*  Copyright (C) 2010-2011, Mamadou Diop.
*  Copyright (C) 2011, Doubango Telecom.
*
*
* Contact: Mamadou Diop <diopmamadou(at)doubango(dot)org>
*
* This file is part of Open Source Doubango Framework.
*
* This is free software: you can redistribute it and/or modify it under the terms of
* the GNU General Public License as published by the Free Software Foundation, either version 3
* of the License, or (at your option) any later version.
*
* This is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
* without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
package org.doubango.ngn.services;

import org.doubango.ngn.model.NgnContact;
import org.doubango.ngn.utils.NgnCallbackFunc;
import org.doubango.ngn.utils.NgnObservableList;

public interface INgnContactService extends INgnBaseService{
	void setOnBeginLoadCallback(NgnCallbackFunc<Object> callback);
	void setOnNewPhoneNumberCallback(NgnCallbackFunc<String> callback);
	void setOnEndLoadCallback(NgnCallbackFunc<Object> callback);
	boolean load();
	boolean isLoading();
	boolean isReady();
	
	NgnContact newContact(int id, String displayName);
	NgnContact getContactByUri(String uri);
	NgnContact getContactByPhoneNumber(String anyPhoneNumber);
	
	NgnObservableList<NgnContact> getObservableContacts();
}
